var accessToken = "";

// 日期格式化函数
function timeFormat(time) {
	var date = new Date(time);
	var month = date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1;
	var day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate();
	return month + "-" + day;
}

$(function() {
	// 页面加载后自动获取token
	if (accessToken == "") {
		accessToken = getToken();
	}
	$("#address").on("click", function() {
		var city = $("#city").val();
		if ($.trim(city) == "") {
			alert("地址不能为空");
			return;
		}
		var query = "address=" + city;
		var path = "v1.0/iot-03/geocode-cities/address";
		timestamp = new Date().getTime();
		var settings = {
			"url": host + "/" + path + "?" + query,
			"method": "GET",
			"timeout": 0,
			"headers": {
				"client_id": clientId,
				"sign": getSignService(accessToken, query, path),
				"t": timestamp,
				"sign_method": sign_method,
				"access_token": accessToken
			}
		};
		// 调用地址解析接口获取坐标
		$.ajax(settings).done(function(response) {
			var lat = response.result.latitude;
			var lon = response.result.longitude;
			var query = "lat=" + lat + "&lon=" + lon;
			var path = "v2.0/iot-03/weather/forecast/daily";
			timestamp = new Date().getTime();
			var settings = {
				"url": host + "/" + path + "?" + query,
				"method": "GET",
				"timeout": 0,
				"headers": {
					"client_id": clientId,
					"sign": getSignService(accessToken, query, path),
					"t": timestamp,
					"sign_method": sign_method,
					"access_token": accessToken
				}
			};
			// 调用天气接口获取未来一周天气情况
			$.ajax(settings).done(function(response) {
				var xAxisData = [];
				var maxSeriesData = [];
				var minSeriesData = [];
				// 解析数据，准备填充Echarts图表
				for (var item of response.result.data) {
					xAxisData.push(timeFormat(item.time));
					maxSeriesData.push(parseFloat(item.temperature_max.Value).toFixed(
						1));
					minSeriesData.push(parseFloat(item.temperature_min.Value).toFixed(
						1));
				}
				// 基于准备好的dom，初始化echarts实例
				var myChart = echarts.init(document.getElementById('main'));
				// 指定图表的配置项和数据
				var option = {
					title: {
						text: (city.indexOf("市") == -1 ? city + "市" : city) +
							" - 未来7天温度变化",
						left: 'center'
					},
					tooltip: {
						trigger: 'axis'
					},
					legend: {
						left: 'right'
					},
					grid: {
						top: "15%"
					},
					xAxis: {
						type: 'category',
						boundaryGap: false,
						data: xAxisData
					},
					yAxis: {
						type: 'value',
						axisLabel: {
							formatter: '{value} °C'
						}
					},
					series: [{
							name: '最高温度',
							type: 'line',
							data: maxSeriesData,
							markPoint: {
								data: [{
										type: 'max',
										name: 'Max'
									},
									{
										type: 'min',
										name: 'Min'
									}
								]
							},
							markLine: {
								data: [{
									type: 'average',
									name: 'Avg'
								}]
							}
						},
						{
							name: '最低温度',
							type: 'line',
							data: minSeriesData,
							markPoint: {
								data: [{
										type: 'max',
										name: 'Max'
									},
									{
										type: 'min',
										name: 'Min'
									}
								]
							},
							markLine: {
								data: [{
									type: 'average',
									name: 'Avg'
								}]
							}
						}
					]
				};
				myChart.setOption(option);
			});
		});
	});
})
