// 根据所在地点设置数据中心地址
// 国内使用替换为 -> https://openapi.tuyacn.com
var host = "https://openapi-ueaz.tuyaus.com";
// clientId 和 secret 进入到项目详情页获取，请自行替换
var clientId = "此处请替换";
var secret = "此处请替换";
// 接口请求类型
var httpMethod = "GET";
// sign加密方式
var sign_method = "HMAC-SHA256";

// 设置ajax为同步（根据需要）
$.ajaxSetup({
	async: false
});

// 将参数键值对解析为json对象
function toJsonObj(params, arr, map) {
	var datas = params.split('&');
	var obj = {};
	for (var item of datas) {
		var data = item.split("=");
		arr.push(data[0]);
		map[data[0]] = data[1];
	}
}

// 获取sign字符串，为最简形式，可根据需要修改
function stringToSign(query, path, method, secret) {
	var sha256 = "";
	var url = "";
	var headersStr = "";
	var map = {};
	var arr = [];
	var bodyStr = "";
	if (query) {
		toJsonObj(query, arr, map);
	}
	sha256 = CryptoJS.SHA256(bodyStr);
	arr = arr.sort();
	arr.forEach(function(item) {
		url += item + "=" + map[item] + "&";
	})
	if (url.length > 0) {
		url = url.substring(0, url.length - 1);
		url = "/" + path + "?" + url;
	} else {
		url = "/" + path;
	}
	var map = {};
	map["signUrl"] = method + "\n" + sha256 + "\n" + headersStr + "\n" + url;
	map["url"] = url;
	return map;
}

// 计算sign：令牌相关操作调用
function calcSignToken(timestamp, signStr, secret) {
	var str = clientId + timestamp + signStr;
	var hash = CryptoJS.HmacSHA256(str, secret);
	var hashInBase64 = hash.toString();
	var signUp = hashInBase64.toUpperCase();
	return signUp;
}

// 计算sign：业务相关操作调用
function calcSignService(accessToken, timestamp, signStr, secret) {
	var str = clientId + accessToken + timestamp + signStr;
	var hash = CryptoJS.HmacSHA256(str, secret);
	var hashInBase64 = hash.toString();
	var signUp = hashInBase64.toUpperCase();
	return signUp;
}

// 获取sign：请求令牌相关接口时调用
function getSignToken(timestamp, query, path) {
	var signMap = stringToSign(query, path, httpMethod, secret);
	var urlStr = signMap["url"];
	var signStr = signMap["signUrl"];
	var sign = calcSignToken(timestamp, signStr, secret);
	return sign;
}

// 获取sign：请求业务相关接口时调用
function getSignService(accessToken, query, path) {
	var signMap = stringToSign(query, path, httpMethod, secret);
	var urlStr = signMap["url"];
	var signStr = signMap["signUrl"];
	var sign = calcSignService(accessToken, timestamp, signStr, secret);
	return sign;
}

// 获取token：简单模式
function getToken() {
	var query = "grant_type=1";
	var path = "v1.0/token";
	var timestamp = new Date().getTime();
	var settings = {
		"url": "https://openapi-ueaz.tuyaus.com/v1.0/token?grant_type=1",
		"method": "GET",
		"timeout": 0,
		"headers": {
			"client_id": clientId,
			"sign": getSignToken(timestamp, query, path),
			"t": timestamp,
			"sign_method": sign_method
		}
	};
	var accessToken = "";
	$.ajax(settings).done(function(response) {
		accessToken = response.result.access_token;
	});
	return accessToken;
}
